diff -ruN ../nakedmudv3.7/lib/pymodules/inform.py lib/pymodules/inform.py
--- ../nakedmudv3.7/lib/pymodules/inform.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/inform.py	2009-03-02 02:58:42.000000000 -0500
@@ -7,56 +7,28 @@
 #
 ################################################################################
 from mud import *
-import utils, char, hooks, mudsock
+import utils, char, hooks, mudsock, string
 
 
 
 ################################################################################
 # utility functions
 ################################################################################
-def see_char_as(ch, tgt):
-    '''returns the proper name one character sees another by'''
-    if ch.cansee(tgt):
-        return tgt.name
-    else:
-        return "someone"
-
-def see_obj_as(ch, obj):
-    '''returns the proper name a character sees an object by'''
-    if ch.cansee(obj):
-        return obj.name
-    else:
-        return "something"
-
-def see_exit_as(ch, ex):
-    '''returns the proper name a character sees an exit by'''
-    if ch.cansee(ex):
-        return ex.name
-    else:
-        return "something"
-
-def show_equipment(ch, tgt):
-    '''shows ch tgt\'s equipment'''
-    for part in tgt.bodyparts:
-        obj = tgt.get_equip(part)
-
-        # if it's not there, or on someone else and we can't see it, skip it
-        if obj == None or (ch != tgt and not ch.cansee(obj)):
-            continue
-
-        ch.send("%-30s %s" % ("{c<{C" + part + "{c>{n", see_obj_as(ch, obj)))
-
-def build_who():
+def build_who(ch = None):
     '''returns a formatted list of all the people currently online'''
-    buf = "--------------------------------------------------------------------------------\r\n"
+    buf = [ ]
+    buf.append("-------------------------------------------------------------------------------")
 
     # build character info
     count   = len(mudsock.socket_list())
     playing = 0
     for sock in mudsock.socket_list():
         if not (sock.ch == None or sock.ch.room == None):
-            buf = buf+(" %-16s %-15s %45s "
-                       % (sock.ch.name,sock.ch.race,sock.ch.user_groups))+"\r\n"
+            desc = sock.ch.name
+            if ch != None:
+                desc = ch.see_as(sock.ch)
+            buf.append(" %-12s %-10s %53s" %
+                       (desc,sock.ch.race,sock.ch.user_groups))
             playing = playing + 1
 
     conn_end = "s"
@@ -65,9 +37,114 @@
     if playing == 1: play_end = ""
 
     # build our footer
-    buf = buf + "--------------------------------------------------------------------------------\r\n" + (" %d socket" % count)  + conn_end + " logged in." + (" %d player" % playing) + play_end + " currently playing.\r\n" + "--------------------------------------------------------------------------------\r\n"
-    
-    return buf
+    buf.append("-------------------------------------------------------------------------------")
+    buf.append((" %d socket" % count)  + conn_end + " logged in." + (" %d player" % playing) + play_end + " currently playing.")
+    buf.append("-------------------------------------------------------------------------------")
+    buf.append("")
+    return "\r\n".join(buf)
+
+
+
+################################################################################
+# look append functions
+################################################################################
+def show_equipment(ch, tgt):
+    '''shows ch tgt\'s equipment'''
+    for obj in tgt.eq:
+        if ch.cansee(obj) or ch == tgt:
+            ch.send("  %-30s %s" % (obj.name, tgt.get_slots(obj)))
+
+cardinal_dirs = ["north", "south", "east", "west"]
+compass_dirs  = ["north", "south", "east", "west",
+                 "northwest", "northeast", "southwest", "southeast"]
+
+def list_one_exit(ch, ex, dir):
+    builder_info = ""
+    if ch.isInGroup("builder"):
+        builder_info = " [" + ex.dest.proto + "]"
+
+    # display the direction we can go
+    ch.send("  {n- %-10s :: %s%s" % (dir, ch.see_as(ex), builder_info))
+                  
+def list_room_exits(ch, room, filter_compass = False):
+    # first, go through our standard exits
+    if not filter_compass:
+        for dir in compass_dirs:
+            ex = room.exit(dir)
+            if ex == None:
+                continue
+            if ex.dest == None:
+                log_string("ERROR: room %s headed %s to %s, which does not exist."%\
+                           room.proto, dir, ex.destproto)
+            elif ch.cansee(ex):
+                list_one_exit(ch, ex, dir)
+
+    # now do special exits
+    for dir in room.exnames:
+        if not dir in compass_dirs:
+            ex = room.exit(dir)
+            if ex.dest == None:
+                log_string("ERROR: room %s headed %s to %s, which does not exist." % \
+                           room.proto, dir, ex.destproto)
+            elif ch.cansee(ex):
+                list_one_exit(ch, ex, dir)
+
+def list_one_furniture(ch, obj):
+    '''list the contents of a piece of furniture to the character.'''
+    sitters = obj.chars
+    am_on   = ch in sitters
+    if am_on:
+        sitters.remove(ch)
+
+    # is it just us now?
+    if len(sitters) == 0:
+        ch.send(obj.rdesc)
+    else:
+        # build display info
+        onat   = obj.furniture_type
+        isare  = "is"
+        if len(sitters) > 1:
+            isare = "are"
+        wth = ""
+        if am_on:
+            wth = " with you"
+        sitter_descs = utils.build_show_list(ch, sitters,
+                                             lambda x: x.name,
+                                             lambda x: x.mname, ", ", True)
+        ch.send("%s %s %s %s%s." % (sitter_descs, isare, onat, obj.name, wth))
+
+def list_room_contents(ch, room):
+    # find our list of visible objects and characters
+    vis_objs  = utils.find_all_objs(ch, room.objs, "", None, True)
+    vis_chars = utils.find_all_chars(ch, room.chars, "", None, True)
+
+    # lists of used furnture, and characters using furniture
+    furniture  = [ ]
+
+    # find our list of used furniture
+    for obj in vis_objs:
+        if len(obj.chars) > 0:
+            furniture.append(obj)
+
+    # now remove our used furniture and people using it from the visible lists
+    for furn in furniture:
+        vis_objs.remove(furn)
+        for pers in furn.chars:
+            vis_chars.remove(pers)
+
+    # show our list of visible characters
+    if ch in vis_chars:
+        vis_chars.remove(ch)
+    if len(vis_chars) > 0:
+        utils.show_list(ch, vis_chars, lambda(x): x.rdesc, lambda(x): x.mdesc)
+
+    # show our list of used furniture
+    for furn in furniture:
+        list_one_furniture(ch, furn)
+
+    # show our list of visible objects
+    if len(vis_objs) > 0:
+        utils.show_list(ch, vis_objs, lambda(x): x.rdesc, lambda(x): x.mdesc)
 
 
 
@@ -85,8 +162,20 @@
         gndr = "You"
         act  = "are"
 
-    ch.send("\n" + gndr + " " + act + " wearing:")
-    show_equipment(ch, tgt)
+    if len(tgt.eq) > 0:
+        ch.send("\n" + gndr + " " + act + " wearing:")
+        show_equipment(ch, tgt)
+
+def room_look_hook(info):
+    '''diplays info about the room contents'''
+    room, ch = hooks.parse_info(info)
+    list_room_exits(ch, room)
+    list_room_contents(ch, room)
+
+def exit_look_hook(info):
+    ex, ch = hooks.parse_info(info)
+    if not ex.is_closed and ch.cansee(ex) and ex.dest != None:
+        list_room_contents(ch, ex.dest)
 
 
 
@@ -94,6 +183,8 @@
 # add our hooks
 ################################################################################
 hooks.add("look_at_char", equipment_look_hook)
+hooks.add("look_at_room", room_look_hook)
+hooks.add("look_at_exit", exit_look_hook)
 
 
 
@@ -103,3 +194,5 @@
 def __unload__():
     '''things that need to be detached when the module is un/reloaded'''
     hooks.remove("look_at_char", equipment_look_hook)
+    hooks.remove("look_at_room", room_look_hook)
+    hooks.remove("look_at_exit", exit_look_hook)
diff -ruN ../nakedmudv3.7/lib/pymodules/movement.py lib/pymodules/movement.py
--- ../nakedmudv3.7/lib/pymodules/movement.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/movement.py	2009-03-02 01:45:15.000000000 -0500
@@ -7,7 +7,7 @@
 ################################################################################
 from mud import *
 from mudsys import add_cmd, add_cmd_check
-import inform, hooks
+import inform, hooks, mudsys, mud
 
 
 
@@ -70,7 +70,7 @@
         return True
 
 def cmd_sit(ch, cmd, arg):
-    '''If standing, attempts to sit instead.'''
+    '''If standing, attempts to sit on the ground.'''
     try:
         obj, = parse_args(ch, True, cmd, arg, "| [on] obj.room")
     except: return
@@ -80,7 +80,7 @@
     elif obj.istype("furniture"):
         try_use_furniture(ch, obj, "sitting")
     else:
-        ch.send("You cannot sit on " + inform.see_obj_as(ch, obj) + ".")
+        ch.send("You cannot sit on " + ch.see_as(obj) + ".")
 
 def cmd_sleep(ch, cmd, arg):
     '''If awake, attempts to lay down and sleep.'''
@@ -93,18 +93,24 @@
     elif obj.istype("furniture"):
         try_use_furniture(ch, obj, "sleeping")
     else:
-        ch.send("You cannot sleep on " + inform.see_obj_as(ch, obj) + ".")
+        ch.send("You cannot sleep on " + ch.see_as(obj) + ".")
 
 def cmd_stand(ch, cmd, arg):
     '''If sitting, attempts to stand. If flying, attempts to land.'''
     try_change_pos(ch, "standing")
 
 def cmd_wake(ch, cmd, arg):
-    '''If sleeping, attempts to wake up and sit.'''
+    '''If sleep, attempts to wake up and sit.'''
     message(ch,None,None,None,True, "to_char", "You stop sleeping and sit up.")
     message(ch,None,None,None,True, "to_room", "$n stops sleeping and sits up.")
     ch.pos = "sitting"
 
+def dir_opposite(dir):
+    '''returns the opposite direction of the specified one, or None if none.'''
+    try:
+        return dir_name[dir_opp[dir_index(dir)]]
+    except: return None
+
 def dir_index(dir):
     '''returns the index of the direction name'''
     try:
@@ -119,67 +125,69 @@
     '''Handles all moving of characters from one room to another, through
        commands. Attempts a move. If successful, returns the exit left through.
        Informs people of our moving'''
-    old_room = ch.room
-    ex       = try_move(ch, dir)
-    dirnum   = dir_index(dir)
-
-    # did we successfully move?
-    if ex != None:
-        new_room = ch.room
-        ch.room  = old_room
-
-        # send out our leave messages as needed
-        if ex.leave_mssg != '':
-            message(ch, None, None, None, True, "to_room", ex.leave_mssg)
-        elif dirnum == -1:
-            message(ch, None, None, None, True, "to_room", "$n leaves.")
-        else:
-            message(ch, None, None, None, True, "to_room",
-                    "$n leaves " + dir_name[dirnum] + ".")
-
-        # send out our enter messages as needed
-        ch.room = new_room
-        if ex.enter_mssg != '':
-            message(ch, None, None, None, True, "to_room", ex.enter_mssg)
-        elif dirnum == -1:
-            message(ch, None, None, None, True, "to_room", "$n has arrived.")
-        else:
-            message(ch, None, None, None, True, "to_room",
-                    "$n arrives from the " + dir_name[dir_opp[dirnum]] + ".")
-
-    # return our exit, whether it existed or not
+    ex, success = try_move(ch, dir, True)
     return ex
 
-def try_move(ch, dir):
+def try_move(ch, dir, mssg = False):
     '''Handles all moving of characters from one room to another, through
        commands. Attempts a move. If successful, returns the exit left
        through.'''
-    ex = ch.room.exit(dir)
+    ex      = ch.room.exit(dir)
+    success = False
 
+    exname = "it"
+    if ex != None and ex.name != "":
+        exname = ex.name
+    
     # did we find an exit?
     if ex == None or not ch.cansee(ex):
         ch.send("Alas, there is no exit in that direction.")
     elif ex.is_closed:
-        exname = ex.name
-        if exname == '':
-            exname = "it"
         ch.send("You will have to open " + exname + " first.")
     elif ex.dest == None:
         ch.send("It doesn't look like " + exname + " leads anywhere!")
     else:
         old_room = ch.room
+        dirnum   = dir_index(dir)
+
+        # send out our leave messages as needed. Is anyone in the old room?
+        if mssg == True:
+            if ex.leave_mssg != '':
+                message(ch, None, None, None, True, "to_room", ex.leave_mssg)
+            elif dirnum == -1:
+                message(ch, None, None, None, True, "to_room", "$n leaves.")
+            else:
+                message(ch, None, None, None, True, "to_room",
+                        "$n leaves " + dir_name[dirnum] + ".")
 
         # run our leave hooks
         hooks.run("exit", hooks.build_info("ch rm ex", (ch, ch.room, ex)))
 
-        ch.room = ex.dest
+        # if a hook hasn't moved us, go through with going through the exit
+        if ch.room == old_room:
+            ch.room = ex.dest
+
+        # stuff that happens before we 'look'
+        hooks.run("pre_enter", hooks.build_info("ch rm", (ch, ch.room)))
+            
         ch.act("look")
 
+        # send out our enter messages as needed
+        if mssg == True:
+            if ex.enter_mssg != '':
+                message(ch, None, None, None, True, "to_room", ex.enter_mssg)
+            elif dirnum == -1:
+                message(ch, None, None, None, True, "to_room","$n has arrived.")
+            else:
+                message(ch, None, None, None, True, "to_room",
+                        "$n arrives from the " + dir_name[dir_opp[dirnum]] +".")
+
         # run our enter hooks
         hooks.run("enter", hooks.build_info("ch rm", (ch, ch.room)))
+        success = True
 
     # return the exit we found (if we found any)
-    return ex
+    return ex, success
 
 def cmd_move(ch, cmd, arg):
     '''A basic movement command, relocating you to another room in the
@@ -215,7 +223,10 @@
 add_cmd("sit",       None, cmd_sit,  "player", True)
 
 # The mud needs to know our command for movement as well
-set_cmd_move(cmd_move)
+mudsys.set_cmd_move(cmd_move)
+
+# useful mud methods
+mud.dir_opposite = dir_opposite
 
 def chk_can_move(ch, cmd):
     if not ch.pos in ["standing", "flying"]:
@@ -224,7 +235,8 @@
 
 for cmd in ["north", "west", "east", "south", "up", "down", "northwest",
             "northeast", "southwest", "southeast", "nw", "ne", "sw", "se"]:
-    add_cmd_check(cmd, chk_can_move)
+    mudsys.register_dflt_move_cmd(cmd)
+mudsys.register_move_check(chk_can_move)
 
 def chk_wake(ch, cmd):
     if not ch.pos == "sleeping":
diff -ruN ../nakedmudv3.7/lib/pymodules/path.py lib/pymodules/path.py
--- ../nakedmudv3.7/lib/pymodules/path.py	2008-05-31 00:18:11.000000000 -0400
+++ lib/pymodules/path.py	2009-03-02 01:45:15.000000000 -0500
@@ -6,7 +6,7 @@
 '''
 from mud import *
 from mudsys import add_cmd
-import mud, mudsys
+import mud, mudsys, room
 
 
 
@@ -20,7 +20,8 @@
             return True
     return False
 
-def shortest_path_bfs(frm, to, ignore_doors = False, ignore = None):
+def shortest_path_bfs(frm, to, ignore_doors = False, stay_zone = True,
+                      ignore = None):
     '''calculates the shortest path, but uses a breadth first search. More
        efficient than depth-first seach for very short paths with lots of
        branches or very large muds.'''
@@ -44,6 +45,11 @@
     rooms.append(frm)
     depth.append(i)
 
+    # figure out what zone we're doing this from
+    zone = None
+    if stay_zone:
+        zone = "@" + frm.proto.split("@")[-1]
+
     # keep going until we find To, or we can't go any deeper
     found = False
     while not found:
@@ -51,7 +57,8 @@
         for rm in prev_depth:
             for ex in rm.exnames:
                 dest = rm.exit(ex).dest
-                if dest in ignore:
+                if (dest == None or dest in ignore or
+                    (stay_zone and not dest.proto.endswith(zone))):
                     continue
                 rooms.append(dest)
                 depth.append(i)
@@ -94,7 +101,8 @@
     path.reverse()
     return path
 
-def shortest_path_dfs(frm, to, ignore_doors = False, ignore = None):
+def shortest_path_dfs(frm, to, ignore_doors = False, stay_zone = True,
+                      ignore = None):
     '''returns the steps needed to take to go from one room to another. More
        efficient than breadth-first search for very long paths with only a few
        branches, or very small muds.'''
@@ -110,6 +118,10 @@
     if frm is to:
         return [frm]
 
+    zone = None
+    if stay_zone:
+        zone = "@" + frm.proto.split("@")[-1]
+
     # build the shortest path 
     for ex in frm.exnames:
         # check if it has a door, and if we ignore it
@@ -123,10 +135,11 @@
             continue
 
         # if we already know this is a dead end or a loopback, skip it
-        if next_room in ignore:
+        if (next_room in ignore or
+            (stay_zone and not next_room.proto.endswith(zone))):
             continue
 
-        next_path = shortest_path(next_room, to, ignore_doors, ignore)
+        next_path = shortest_path(next_room, to, ignore_doors, stay_zone,ignore)
 
         # dead end
         if len(next_path) == 0:
@@ -159,7 +172,7 @@
     # return the directions we generated, if any
     return dirs
 
-def build_patrol(rms, reverse = True):
+def build_patrol(rms, reverse = True, ignore_doors = False, stay_zone = True):
     '''builds a set of directions that need to be followed to do a patrol
        between the rooms. If reverse is true, also supplies the directions
        to loop back on itself'''
@@ -171,13 +184,13 @@
     path = []
     i    = 0
     while i < len(rms) - 1:
-        path = path + shortest_path(rms[i], rms[i+1])
+        path.extend(shortest_path(rms[i], rms[i+1], ignore_doors, stay_zone))
         i += 1
     return path_to_dirs(path)
 
-def step(frm, to, ignore_doors = False):
+def step(frm, to, ignore_doors = False, stay_zone = True):
     '''returns the first step needed to take to go from one room to another'''
-    steps = shortest_path(frm, to, ignore_doors)
+    steps = shortest_path(frm, to, ignore_doors, stay_zone)
     if steps == None or len(steps) <= 1:
         return None
     return path_to_dirs(steps)[0]
@@ -193,10 +206,11 @@
        Prints out a Python list of the directions needed to move from your
        current location to the location of the specified person.'''
     try:
-        tgt, = parse_args(ch, True, cmd, arg, "ch.world.noself")
+        dest, = parse_args(ch, True, cmd, arg, "room")
     except: return
 
-    path = build_patrol([ch.room, tgt.room])
+    path = build_patrol([ch.room, dest])
+
     if len(path) == 0:
         ch.send("Path doesn't exist")
     else:
diff -ruN ../nakedmudv3.7/lib/pymodules/routine.py lib/pymodules/routine.py
--- ../nakedmudv3.7/lib/pymodules/routine.py	2008-12-06 00:20:20.000000000 -0500
+++ lib/pymodules/routine.py	2009-03-02 01:45:15.000000000 -0500
@@ -60,7 +60,8 @@
 ################################################################################
 def register_routine_check(check):
     '''adds a routine check to the global list. Must be a function taking one
-       argument, which is the character doing the routine'''
+       argument, which is the character doing the routine. Return should be
+       True if the check succeeded (i.e., we should not do a routine)'''
     __global_routine_checks__.append(check)
 
 def start_routine(ch):
@@ -166,17 +167,17 @@
 def cmd_routine(ch, cmd, arg):
     '''Appends a routine onto a character. The second argument needs to be an
        evaluable list statement. Put it in parentheses to avoid being cut off
-       as spaces, since parse treats it as a single word. Example: 
-    
+       as spaces, since parse treats it as a single word. Example:
+
          > routine man "[\'say hi\', (3, \'say I am a little teapot\')]" True
-    
+
        this will say hi after the default delay, and I am a little teapot after
        a delay of 3. It will then loop through this process indefinitely.
        Alternatively, these commands can be replaced with function calls.
        '''
     try:
         tgt, routine, repeat = parse_args(ch, True, cmd, arg,
-                                          "ch.room.noself word | bool")
+                                          "ch.room.noself word(py_list) | bool(repeat)")
     except:
         return
 
diff -ruN ../nakedmudv3.7/lib/pymodules/utils.py lib/pymodules/utils.py
--- ../nakedmudv3.7/lib/pymodules/utils.py	2008-12-06 00:20:20.000000000 -0500
+++ lib/pymodules/utils.py	2009-03-02 02:59:02.000000000 -0500
@@ -5,7 +5,13 @@
 # Various utility functions used by other Python modules.
 #
 ################################################################################
+import mud
 
+
+
+################################################################################
+# utility functions
+################################################################################
 def parse_keywords(kw):
     '''turns a comma-separated list of strings to a list of keywords'''
     list = kw.lower().split(",")
@@ -40,6 +46,32 @@
             return True
     return False
 
+def find_all_chars(looker, list, name, proto = None, must_see = True):
+    '''returns a list of all the chars that match the supplied constraints'''
+    found = []
+    for ch in list:
+        if must_see and not looker.cansee(ch):
+            continue
+        elif name != None and is_keyword(ch.keywords, name, True):
+            found.append(ch)
+        elif proto != None and ch.isinstance(proto):
+            found.append(ch)
+    return found
+
+def find_char(looker, list, num, name, proto = None, must_see = True):
+    '''returns the numth char to match the supplied constraints'''
+    count = 0
+    for ch in list:
+        if must_see and not looker.cansee(ch):
+            continue
+        elif name != None and is_keyword(ch.keywords, name, True):
+            count = count + 1
+        elif proto != None and ch.isinstance(proto):
+            count = count + 1
+        if count == num:
+            return ch
+    return None
+
 def find_all_objs(looker, list, name, proto = None, must_see = True):
     '''returns a list of all the objects that match the supplied constraints'''
     found = []
@@ -83,11 +115,15 @@
     except:
         return 1, str
 
-def show_list(ch, list, s_func, m_func = None):
-    '''shows a list of things to the character. s_func is the description if
+def build_show_list(ch, list, s_func, m_func = None, joiner = "\r\n",
+                    and_end=False):
+    '''builds a list of things to show a character. s_func is the description if
        there is only a single item of the type. m_func is the description if
        there are multiple occurences of the thing in the list'''
 
+    # the outbound info
+    buf = [ ]
+
     # maps descriptions to counts
     counts = { }
 
@@ -106,13 +142,25 @@
 
             # display our item(s)
             if count == 1:
-                ch.send(s_func(thing))
+                buf.append(s_func(thing))
             elif m_func == None or m_func(thing) == "":
-                ch.send("(" + str(count) + ") " + s_func(thing))
+                buf.append("(" + str(count) + ") " + s_func(thing))
             else:
-                ch.send(m_func(thing) % count)
+                buf.append(m_func(thing) % count)
         else: pass
 
+    # do we have to put "and" at the end?
+    if and_end and len(buf) > 1:
+        last = buf.pop()
+        return joiner.join(buf) + " and " + last
+    return joiner.join(buf)
+
+def show_list(ch, list, s_func, m_func = None):
+    '''shows a list of things to the character. s_func is the description if
+       there is only a single item of the type. m_func is the description if
+       there are multiple occurences of the thing in the list'''
+    ch.send(build_show_list(ch, list, s_func, m_func, "\r\n"))
+
 def olc_display_table(sock, list, num_cols, disp = lambda x: x):
     '''used by OLC functions to display a list of options in a table form.
        Also displays each option\'s position number and colorizes everything.'''
@@ -131,3 +179,14 @@
     # do we need to end this with a newline?
     if i % num_cols != 0:
         sock.send_raw("\r\n")
+
+def aan(word):
+    '''return "a" or "an", depending on the word.'''
+    if len(word) == 0 or not word[0].lower() in "aeiou":
+        return "a " + word
+    return "an " + word
+
+def chk_conscious(ch, cmd):
+    if ch.pos in ["sleeping", "unconscious"]:
+        ch.send("You cannot do that while " + ch.pos + "!")
+        return False
